<template>
  <!--
    The tooltip for this element needs to live on a wrapping div
    because disabled buttons don't send events to the DOM (so
    the hover leave will never trigger if the user's mouse leaves
    the button while it's loading.)
  -->
  <div
    v-b-tooltip.hover.v-primary
    :title="tooltip"
  >
    <base-button-icon
      :color="color"
      :disabled="!isAuthenticated"
      :size="size"
      icon="edit"
      @click="$emit('commenting')"
    />
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapGetters } from 'vuex';

import BaseButtonIcon from '@/components/BaseButtonIcon.vue';

export default Vue.extend({
  components: {
    BaseButtonIcon,
  },

  props: {
    color: {
      default: 'gray',
      required: false,
      type: String,
    },

    size: {
      default: 'md',
      required: false,
      type: String,
    },
  },

  computed: {
    ...mapGetters(['isAuthenticated']),
    tooltip(): string {
      if (!this.isAuthenticated) {
        return 'Login to annotate this locus';
      }
      return 'Annotate this locus';
    },
  },
});
</script>
